/*
TODO: 
  make a query
  draw a Bar (3.2h*6 long by h high)
  make 6 subdivisions of the bar
  [impl both by drawing a box with fill color x and stroke black x 6]
  nope further subdivide: instead of 1 bibg box, loop which draws 12 little boxes.
  fine sub div width = 3.2h/12
  actual height is 3 h simply because space around the image is needed, simlarly, length is 7 boxes, not 6 to give a border.
*/

import de.bezier.data.sql.*;
BufferedReader queryLoader;

MySQL msql;
String query="";
String next;
int totalBooks;

int [] totalCheckouts;
int [] totalPerMonth;
int [][] individualCount;
int [][] individualCountYear;
int [] totalPerYear;
color [] colors= {color(0,0,255),color(0,255,0),color(255,0,0),color(255,0,255),color(255,255,0),color(0,255,255),color(125,125,255),color(125,255,125),color(255,125,125),color(125,125,125)};
String [] titles = { "Lord of the Rings\nReturn of the King","The Hobbit or There\nand Back Again","Game of Thrones","Name of the Wind\nthe Kingkiller Chronicles","American Gods","Jonathan Strange and Mr. Norrell","Dance with Dragons","Mists of Avalon","Silmarillion","Pawn of Prophecy"};
int w = 800;
int h = 800;
int brOff=w/14;
int tickMarkLength=10;
int pointRad=5;
int legendSpace=w/5;
int titleSpace=h/10;
int hH =h-titleSpace-brOff;
int wH =w-legendSpace-brOff;
int hzoom=14;
int wzoom=2;
int wzoomm1=3;
int hzoomm1=1;
int tOff=5;
int radSmall=2;
int radLarge=10;

int mode=0;

void setup(){
  //noLoop();
  size(w,h);
queryLoader = createReader("Query.txt");
try{
  //load the query from file (to long for anyuthing else)
while ((next = queryLoader.readLine()) !=null)
  query+=" "+next;
} catch (IOException e){
  exit();
}

totalCheckouts = new int [10];
totalPerMonth = new int [85];
individualCount = new int [10][85];
individualCountYear = new int [10][7];
totalPerYear = new int [7];
  
  msql = new MySQL(this, "tango.mat.ucsb.edu","spl1","mat259","V1sual1zat1on");
 if ( msql.connect() )
  {
      msql.query(query);
      for (int i=0; i<85; i++){
        msql.next();
        for (int j=2; j<=11; j++){
          //collect all the relevant data points
          individualCount[j-2][i]=msql.getInt(j);
          totalCheckouts[j-2]+=msql.getInt(j);
          totalPerMonth[i]+=msql.getInt(j);
          if(i==84)
            continue;
          individualCountYear[j-2][i/12]+=msql.getInt(j);
          totalPerYear[i/12]+=msql.getInt(j);
        }
      }
  }
  else
  {
      // connection failed !
  }


}
/*
todo: draw a simple plot, plot the flow graph
*/
void draw(){
  textSize(12);
  background(255);
  if (mode==0){
   line(brOff, h-brOff,w-legendSpace,h-brOff);
   line(brOff, titleSpace ,brOff,h-brOff);
   stroke(0);
   for (int i=0; i<85; i++){
     for (int j=0; j<10; j++){
       int rad =(int)(radSmall+(radLarge-radSmall)*(i/85.));
       //stroke(colors[j]);
       fill(colors[j],200);
       ellipse(1+(wH*wzoom*individualCount[j][i]/totalPerMonth[i])+brOff+rad,(h-brOff)-(hH*hzoom*individualCount[j][i]/totalCheckouts[j])-rad,2*rad,2*rad);
       //line(1+(wH*wzoom*individualCount[j][i]/totalPerMonth[i])+brOff+pointRad,(h-titleSpace)-(hH*hzoom*individualCount[j][i]/totalCheckouts[j])-pointRad,1+(wH*wzoom*individualCount[(j+11)%10][(i+86)%85]/totalPerMonth[(i+86)%85])+brOff+pointRad,(h-titleSpace)-(hH*hzoom*individualCount[(j+11)%10][(i+86)%85]/totalCheckouts[(j+11)%10])-pointRad);
     }
   }
   // do chart labels
   stroke(0);
   fill(0);
   textAlign(CENTER,CENTER);
   text("Individual Count/ Month Total", w/2,h-brOff/2);
     pushMatrix();
    translate(tOff,h/2);
    rotate(-HALF_PI);
     text("Individual Count/ Total in all years",0,0);
    popMatrix();
 textSize(18);
 text("Popularity over Time Versus Popularity per Month", w/2,titleSpace/2);
  tickMarks(wzoom,hzoom);
 }  
 else if (mode ==1){
   line(brOff, h-brOff,w-legendSpace,h-brOff);
   line(brOff, titleSpace ,brOff,h-brOff);
   for (int i=0; i<7; i++){
     for (int j=0; j<10; j++){
       stroke(0);
       fill(colors[j]);
       ellipse(1+(wH*wzoomm1*individualCountYear[j][i]/totalPerYear[i])+brOff+pointRad,(h-brOff)-(hH*hzoomm1*individualCountYear[j][i]/totalCheckouts[j])-pointRad,2*pointRad,2*pointRad);
        if(i==6)
          continue;
      stroke(colors[j],255/20*(10+j));
       line(1+(wH*wzoomm1*individualCountYear[j][i]/totalPerYear[i])+brOff+pointRad,(h-brOff)-(hH*hzoomm1*individualCountYear[j][i]/totalCheckouts[j])-pointRad,1+(wH*wzoomm1*individualCountYear[j][(i+8)%7]/totalPerYear[(i+8)%7])+brOff+pointRad,(h-brOff)-(hH*hzoomm1*individualCountYear[j][(i+8)%7]/totalCheckouts[j])-pointRad);
     }
   }
   // do chart labels
     stroke(0);
   fill(0);
   textAlign(CENTER,CENTER);
   text("Individual Count/ Year Total", w/2,h-brOff/2);
     pushMatrix();
    translate(tOff,h/2);
    rotate(-HALF_PI);
     text("Individual Count/ Total in all years",0,0);
    popMatrix();
 textSize(18);
 text("Popularity over Time Versus Popularity per Year", w/2,titleSpace/2);
   tickMarks(wzoomm1,hzoomm1);
 }
/*
use 1/8 margins top/bot
*/
for (int i=0; i<10; i++){
  fill(colors[i]);
  noStroke();
  rect(w-legendSpace/2,h/8+3*h/4/10*i,10,10);
}

}

void tickMarks(int xScaling, int yScaling){
  textSize(10);
   for (int i=0; i<=10; i++){
     line(brOff+wH/10*i,h-brOff,brOff+wH/10*i,h-brOff+tickMarkLength); //x tick
     line(brOff,h-brOff-i*hH/10,brOff-tickMarkLength,h-brOff-i*hH/10); //y tick
     String x = nfc(100./xScaling/10*i,2);
     String y = nfc(100./yScaling/10*i,2);
     x+="%";
     y+="%";
     textAlign(CENTER,TOP);
     text(x,brOff+wH/10*i,h-brOff+tickMarkLength+tOff); //x label
     textAlign(RIGHT,CENTER);
     text(y,brOff-tickMarkLength,h-brOff-i*hH/10+tOff); //y label
     
 }
}

void mousePressed(){
   mode+=1;
   mode = mode%2;
}
